#if !defined(_GLOBAL_H_INCLUDED_)
#define _GLOBAL_H_INCLUDED_

#define HTML        48
#define IMAGE       49
#define AUDIO       50
#define VIDEO       51
#define DYNAMIC     52
#define FORMATTED   53
#define COMPRESSED  54
#define PROGRAMS    55
#define DIRECTORY   56
#define OTHER_TYPES 57

extern char *TypeName[];
extern int field;

#include <assert.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <vector>
#include <algorithm>
#include <stdarg.h>
#include <iostream>

using namespace std; // for STL

typedef __int64 INT64;

typedef vector<int> VecInt;
typedef vector<double> VecDouble;
typedef vector<INT64> VecInt64;
typedef VecInt* PVecInt;
typedef vector<PVecInt> VecPVecInt;
typedef char* PChar;
typedef vector<PChar> VecPChar;

extern VecPChar vecName;
extern VecInt vecScale;

typedef int BOOL;
#define TRUE 1
#define FALSE 0

typedef struct TraceRec
{
  union{
    struct{
      int interval; //microseconds passed since the previous request
      int servicetime; //microseconds were required to service this request
      int objid;
      int clientid;
      int size;
      int type;
    };
    int field[6];
  };
}* PTraceRec;

enum{
  INTERVAL=0,
  SERVICETIME,
  OBJID,
  CLIENTID,
  SIZE,
  TYPE,
  MAX,
  OBJIDSIZE
};

BOOL greater(int &a, int &b);

inline void tomax(int &x, int y)
{
  assert(y>=0);
  if (x<y)
    x=y;
}

inline void vecassign(VecInt &v, int idx, int data, int def=0)
{
  int i, s;

  s=v.size();
  if (idx>s-1)
  {
    for (i=0; i<=idx-s; i++)
      v.push_back(def); // default value
  }
  v[idx]=data;
}

inline void vecinc(VecInt &v, int idx, int def=1)
{
  int i, s;

  s=v.size();
  if (idx>s-1)
  {
    for (i=0; i<=idx-s; i++)
      v.push_back(0); // default value
  }
  v[idx] += def;
}

inline int nonzero(VecInt &v)
{
  int i,n;

  for (i=n=0; i<v.size(); i++)
  {
    if (v[i]!=0)
      n++;
  }
  return n;
}
#endif // !defined(_GLOBAL_H_INCLUDED_)
