// Model.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "RandGen.h"
#include "DistribFunc.h"
#include "SingleDistrib.h"
#include "SynTrace.h"

#define MAX_SEED 500
int Seeds[MAX_SEED];
int curSeed=0;

void InitSeed(int seed, int streamLen)
{
  RandGen r;
  int step;
  ifstream f;

  f.open("RandSeed500000.txt");
  if (!f)
    Error("Open seed file error!");
  step=0;

  /* gen seeds
  int i;
  r.srandom(seed);
  for (step = 0; step < MAX_SEED; step++)
  {
    for (i=0; i<streamLen-1; i++)
      r.random();
    Seeds[step]=r.random();
    f << Seeds[step] << endl;
  }
  //*/
  //*
  while (step<MAX_SEED && !f.eof())
  {
    f >> Seeds[step];
    step++;
  }
  //*/
}

int GetSeed()
{
  if (curSeed>=MAX_SEED)
    Error("No enough seed!");
  return Seeds[curSeed++];
}

void Error(char *fmt, ...)
{
  va_list args;

  cerr << "Error: ";

  va_start(args, fmt);
  vfprintf(stderr, fmt, args);
  fprintf(stderr, "\n");
  va_end(args);
    
  exit(1);
}

// read a line, ignore comment lines and empty lines
void ReadLine(ifstream &f, char line[], int len)
{
  do
  {
    f.getline(line,len);
  }while (IsBlank(line) && !f.eof());
}

BOOL IsBlank(char line[])
{
  char *pch;
  pch = line;
  while ((*pch==' ')||(*pch=='\t'))
    pch++;
  if ((*pch==0)||(*pch=='#'))
    return TRUE;
  else
    return FALSE;
}

int main(int argc, char* argv[])
{
  SynTrace synTrace(1);

  if (argc!=2)
    Error("Usage: model <cfg file>");

  synTrace.ReadConfig(argv[1]);
  synTrace.GenTrace();
	return 0;
}
