// srv_and_size.h: interface for the TrcLimit class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(SRV_AND_SIZE_H_INCLUDED_)
#define SRV_AND_SIZE_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ScanTrace.h"

class SrvAndSize : public ScanTrace  
{
protected:
  FILE *f;
  int line;
public:
	SrvAndSize(FILE *fout) : ScanTrace(fout)
  {
    line=0;
    if ((f=fopen("size_and_srv.txt","wt"))==NULL)
    {
      printf("Create %s error!\n","size_and_srv.txt");
      exit(1);
    }
  };

  virtual ~SrvAndSize()
  {
    printf("Deleting SrvAndSize...\n");

    fclose(f);
  };

  virtual void pre_process(TraceRec &rec)
  {
  };

  virtual void process_one(TraceRec &rec)
  {
    line++;
    if (line % 1000 != 0)
      return;
    fprintf(f,"%d %d\n",rec.size,rec.servicetime);
  };
};

#endif // !defined(SRV_AND_SIZE_H_INCLUDED_)
