// type_byte.h: interface for the TrcLimit class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_TYPE_BYTE_H_INCLUDED_)
#define _TYPE_BYTE_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ScanTrace.h"

class TypeByte : public ScanTrace  
{
protected:
  VecDouble vecMean, vecCov, vecStdv;
  VecDouble vecTypeByte, vecSqrSum;
  VecInt64 vecTypeNum;
  VecPVecInt vecBytes;
  INT64 totalbytes, totalnum;
public:
	TypeByte(FILE *fout) : ScanTrace(fout)
  {
    int i;
    for (i=HTML; i<=OTHER_TYPES; i++)
    {
      vecTypeByte.push_back(0);
      vecTypeNum.push_back(0);
      vecBytes.push_back(new VecInt);
      vecSqrSum.push_back(0);
      vecMean.push_back(0);
      vecCov.push_back(0);
      vecStdv.push_back(0);
    }
    totalbytes=totalnum=0;
  };

  virtual ~TypeByte()
  {
    double d;
    printf("Deleting TypeByte...\n");
    int i, median, n;
    for (i=0; i<=OTHER_TYPES-HTML; i++)
    {
      if (vecTypeNum[i]==0)
        continue;
      vecMean[i]=double(vecTypeByte[i])/vecTypeNum[i];
      d = sqrt((vecSqrSum[i]-vecTypeNum[i]*vecMean[i]*vecMean[i])/vecTypeNum[i]);
      vecStdv[i] = d;
      vecCov[i] = vecStdv[i]/vecMean[i];
      for (median=n=0; median<vecBytes[i]->size(); median++)
      {
        n += (*vecBytes[i])[median];
        if (n*2>=vecTypeNum[i])
          break;
      }
      for (n=0,median=vecBytes[i]->size()-1; median>=0; median--)
      {
        n += (*vecBytes[i])[median];
        if (n*2>=vecTypeNum[i])
          break;
      }
      double percent,byte;
      percent = double(vecTypeByte[i])/totalbytes*100;
      byte = vecTypeByte[i];
      fprintf(m_fout,"%s: size:%4.2lf%% %lf num:%I64d %4.2lf%% \n\
mean size: %lf median size: %d stdv:%lf cov:%lf\n\n",
        TypeName[i],percent,byte,
        vecTypeNum[i], double(vecTypeNum[i])/totalnum*100,
        vecMean[i], median, vecStdv[i], vecCov[i]);
    }

    for (i=HTML; i<=OTHER_TYPES; i++)
    {
      delete vecBytes[i-HTML];
    }
  };

  virtual void pre_process(TraceRec &rec)
  {
  };

  virtual void process_one(TraceRec &rec)
  {
    totalbytes += rec.size;
    totalnum++;
    vecTypeByte[rec.type - HTML] += rec.size;
    if (vecTypeByte[rec.type - HTML]<0) 
    {
      printf("vecTypeByte too big\n");
      exit(1);
    }
    vecSqrSum[rec.type - HTML] += double(rec.size)*rec.size;
    if (vecSqrSum[rec.type - HTML]<0) 
    {
      printf("vecSqrSum too big\n");
      exit(1);
    }
    assert(rec.type >= HTML && rec.type <= OTHER_TYPES);
    vecTypeNum[rec.type - HTML]++;
    vecinc(*vecBytes[rec.type - HTML], rec.size);
  };
};

#endif // !defined(_TYPE_BYTE_H_INCLUDED_)
